PROGRAM Biester_Evolution (input, output);


CONST Max_Nr_Biest = 50;
      Max_Schwanzlaenge = 10;


TYPE biotop = ARRAY[0..399, 0..399] OF BOOLEAN;
     richtg = 0..5;

     richtung = ARRAY[richtg] OF INTEGER;

     individuum = RECORD
                    xposi, yposi : ARRAY[1..Max_Schwanzlaenge] OF INTEGER;
                    energie, alter : INTEGER;
                    direction : richtg;
                    tot : BOOLEAN;
                    gene : richtung;
                  END;

     population = ARRAY[1..Max_Nr_Biest] OF individuum;


VAR pop : population;
    tuempel : biotop;
    xzug, yzug : richtung;

    gesamt_wahrsch : REAL;

    i, j, X_Schirm, Y_Schirm, X_Grenze, Y_Grenze, biester, max_biester,
     bakterien, schwanz, pli, pre, pun, pob : INTEGER;

    init_bakt, init_biest, ausg : BOOLEAN;

    key, ch : CHAR;



{$I E:\PASLIBS\screen.inc}

{$I E:\PASLIBS\getzahl.inc}

{$I E:\PASLIBS\random.inc}


{$I E:\PASLIBS\min_max.inc}

{$I E:\PASLIBS\potenz.inc}



PROCEDURE clear_links;

VAR i : BYTE;

BEGIN  { clear_links }
  FOR i:=0 TO 24 DO
   BEGIN
     gotoxy(50, i); end_of_line
   END;  { FOR }
END;  { clear_links }



PROCEDURE draw_box (x, y : INTEGER;
                    bedroht : BOOLEAN);

VAR li, re, un, ob : INTEGER;

BEGIN  { draw_box }
  li:=x - 3; re:=x + 3;
  un:=y - 3; ob:=y + 3;

  line(li, un, li, ob, 1, 0, 0, 0, 0, 3);
  line(li, ob, re, ob, 1, 0, 0, 0, 0, 3);
  line(re, ob, re, un, 1, 0, 0, 0, 0, 3);
  line(re, un, li, un, 1, 0, 0, 0, 0, 3);


  IF bedroht
   THEN BEGIN
          li:=x - 2; re:=x + 2;
          un:=y - 2; ob:=y + 2;
          line(li, un, li, ob, 1, 0, 0, 0, 0, 3);
          line(li, ob, re, ob, 1, 0, 0, 0, 0, 3);
          line(re, ob, re, un, 1, 0, 0, 0, 0, 3);
          line(re, un, li, un, 1, 0, 0, 0, 0, 3);

          li:=x - 1; re:=x + 1;
          un:=y - 1; ob:=y + 1;
          line(li, un, li, ob, 1, 0, 0, 0, 0, 3);
          line(li, ob, re, ob, 1, 0, 0, 0, 0, 3);
          line(re, ob, re, un, 1, 0, 0, 0, 0, 3);
          line(re, un, li, un, 1, 0, 0, 0, 0, 3)
        END  { IF }
END;  { draw_box }



PROCEDURE undraw_box (VAR sea : biotop;
                      x, y : INTEGER;
                      bedroht : BOOLEAN);

VAR li, re, un, ob : INTEGER;


 PROCEDURE update_lake (VAR see : biotop);

 VAR i, j : INTEGER;

 BEGIN  { update_lake }
   FOR i:=li TO re DO
    FOR j:=un TO ob DO
     IF see[i, j] THEN put_pixel(i, j, 1)
 END;  { update_lake }


BEGIN  { undraw_box }
  li:=x - 3; re:=x + 3;
  un:=y - 3; ob:=y + 3;

  line(li, un, li, ob, 0, 0, 0, 0, 0, 3);
  line(li, ob, re, ob, 0, 0, 0, 0, 0, 3);
  line(re, ob, re, un, 0, 0, 0, 0, 0, 3);
  line(re, un, li, un, 0, 0, 0, 0, 0, 3);

  IF bedroht
   THEN BEGIN
          li:=x - 2; re:=x + 2;
          un:=y - 2; ob:=y + 2;
          line(li, un, li, ob, 0, 0, 0, 0, 0, 3);
          line(li, ob, re, ob, 0, 0, 0, 0, 0, 3);
          line(re, ob, re, un, 0, 0, 0, 0, 0, 3);
          line(re, un, li, un, 0, 0, 0, 0, 0, 3);

          li:=x - 1; re:=x + 1;
          un:=y - 1; ob:=y + 1;
          line(li, un, li, ob, 0, 0, 0, 0, 0, 3);
          line(li, ob, re, ob, 0, 0, 0, 0, 0, 3);
          line(re, ob, re, un, 0, 0, 0, 0, 0, 3);
          line(re, un, li, un, 0, 0, 0, 0, 0, 3)
        END;  { IF }

  update_lake(sea)
END;  { undraw_box }



PROCEDURE init (VAR bev : population; VAR teich : biotop;
                VAR biest_number, tail_len, bakt_number,
                li, re, un, ob : INTEGER;
                VAR ini_biest, ini_bakt : BOOLEAN);

VAR i, j, x, y, hilf : INTEGER;

BEGIN  { init }
  IF NOT(ini_bakt)
   THEN BEGIN
          clear_home;
          gotoxy(50, 1); write('Initialisierung ...');


          FOR i:=0 TO X_Schirm DO
           FOR j:=0 TO Y_Schirm DO teich[i, j]:=FALSE;


          i:=li; hilf:=0;
          WHILE (i <= re) DO
           BEGIN

             j:=un;
             WHILE (j <= ob) DO
              BEGIN
                teich[i, j]:=TRUE; put_pixel(i, j, 1);
                hilf:=succ(hilf);

                j:=j + 5
              END;  { WHILE }

             i:=i + 5
           END;  { WHILE }

          FOR i:=1 TO bakt_number DO
           BEGIN
             x:=random(X_Schirm);
             y:=random(Y_Schirm);
             teich[x, y]:=TRUE;
             put_pixel(x, y, 1)
           END;  { FOR }

          bakt_number:=bakt_number + hilf;
          ini_bakt:=TRUE;


          gotoxy(50, 1); write('                   ')
        END;  { IF }


  IF NOT(ini_biest)
   THEN BEGIN
          FOR i:=1 TO Max_Nr_Biest DO
           WITH bev[i] DO
            BEGIN
              energie:=0;
              alter:=1;
              tot:=TRUE
            END;  { WITH }


          FOR i:=1 TO biest_number DO
           WITH bev[i] DO
            BEGIN
              x:=random(X_Schirm);
              y:=random(Y_Schirm);


              IF (x < 3)
               THEN x:=X_Schirm - 3
               ELSE IF (x > (X_Schirm - 3)) THEN x:=3;
              IF (y < 3)
               THEN y:=Y_Schirm - 3
               ELSE IF (y > (Y_Schirm - 3)) THEN y:=3;


              FOR j:=1 TO tail_len DO
               BEGIN
                 xposi[j]:=x;
                 yposi[j]:=y
               END;  { FOR }

              draw_box(x, y, FALSE);


              energie:=40;
              direction:=random(5);
              tot:=FALSE;

              FOR j:=0 TO 5 DO gene[j]:=round(-2.0 + 4.0 * random_0_1);
              ini_biest:=TRUE
            END  { WITH }
        END  { IF }
END;  { init }



PROCEDURE bewege (VAR biest : individuum; VAR teich : biotop;
                  tail_len : INTEGER);

VAR i : richtg;
    j : INTEGER;
    sum_wahrsch, zuza : REAL;
    wahrsch, intervall : ARRAY[richtg] OF REAL;

BEGIN  { bewege }
  sum_wahrsch:=0.0;
  FOR i:=0 TO 5 DO
   BEGIN
     wahrsch[i]:=potenz(2.0, biest.gene[i]);

     sum_wahrsch:=sum_wahrsch + wahrsch[i]
   END;  { FOR }

  FOR i:=0 TO 5 DO wahrsch[i]:=wahrsch[i] / sum_wahrsch;

  intervall[0]:=wahrsch[0];
  FOR i:=1 TO 5 DO intervall[i]:=intervall[pred(i)] + wahrsch[i];


  zuza:=random_0_1;

  i:=0;
  WHILE (zuza > intervall[i]) DO i:=succ(i);


  WITH biest DO
   BEGIN
     undraw_box(teich,
                xposi[tail_len], yposi[tail_len],
                ((energie < 15) OR (alter > 1985)));

     FOR j:=tail_len DOWNTO 2 DO
      BEGIN
        xposi[j]:=xposi[pred(j)];
        yposi[j]:=yposi[pred(j)]
      END;  { FOR }


     direction:=(direction + i) MOD 6;

     xposi[1]:=xposi[1] + xzug[direction];
     yposi[1]:=yposi[1] + yzug[direction];


     IF (xposi[1] < 3)
      THEN xposi[1]:=X_Grenze
      ELSE IF (xposi[1] > X_Grenze) THEN xposi[1]:=3;
     IF (yposi[1] < 3)
      THEN yposi[1]:=Y_Grenze
      ELSE IF (yposi[1] > Y_Grenze) THEN yposi[1]:=3;

     energie:=pred(energie);
     alter:=succ(alter);

     draw_box(xposi[1], yposi[1],
              ((energie < 15) OR (alter > 1985)));
   END  { WITH }
END;  { bewege }



FUNCTION mampfe (VAR teich : biotop; xpos, ypos : INTEGER) : INTEGER;

VAR i, j, bak, li, re, un, ob : INTEGER;

BEGIN  { mampfe }
  bak:=0;

  li:=xpos - 3; re:=xpos + 3;
  un:=ypos - 3; ob:=ypos + 3;

  FOR i:=li TO re DO
   FOR j:=un TO ob DO
    IF teich[i, j]
     THEN BEGIN
            bak:=succ(bak);
            teich[i, j]:=FALSE; put_pixel(i, j, 0)
          END;  { IF }

  mampfe:=bak
END;  { mampfe }



PROCEDURE vermehre_oder_loesche (VAR be : population; VAR teich : biotop;
                                 VAR alive, max_biest, tail_len : INTEGER;
                                 VAR clear : BOOLEAN);

VAR i, j : INTEGER;


 FUNCTION finde_erstes_totes (VAR b : population; bis : INTEGER) : INTEGER;

 VAR i : INTEGER;

 BEGIN  { finde_erstes_totes }
   i:=1;
   WHILE NOT(b[i].tot) AND (i < bis) DO i:=succ(i);

   finde_erstes_totes:=i
 END;  { finde_erstes_totes }


 PROCEDURE mutiere (VAR biest : individuum);

 VAR i, stelle : richtg;

 BEGIN  { mutiere }
   stelle:=random(5);

   WITH biest DO
    IF (random_0_1 < 0.5)
     THEN gene[stelle]:=succ(gene[stelle])
     ELSE gene[stelle]:=pred(gene[stelle])
 END;  { mutiere }


BEGIN  { vermehre_oder_loesche }
  clear:=FALSE;

  FOR i:=1 TO max_biest DO
   WITH be[i] DO
    IF NOT(tot)
     THEN IF (energie <= 0) OR (alter > 2000)
           THEN BEGIN
                  tot:=TRUE;

                  FOR j:=1 TO tail_len DO
                   undraw_box(teich,
                              xposi[j], yposi[j],
                              ((energie < 15) OR (alter > 1985)));

                  alive:=pred(alive);
                  clear:=TRUE
                END  { IF }
           ELSE IF (alive < max_biest)
                 THEN IF (alter >= 800) AND (energie >= 1000)
                        THEN BEGIN
                               energie:=energie DIV 2;
                               alter:=1;

                               j:=finde_erstes_totes(be, max_biest);
                               be[j]:=be[i];

                               mutiere(be[i]);
                               mutiere(be[j]);

                               alive:=succ(alive);
                               clear:=TRUE
                             END  { IF }
END;  { vermehre_oder_loesche }



PROCEDURE evolution (VAR bev : population; VAR teich : biotop;
                     VAR biestzahl, max_biestzahl, tail,
                     li, re, un, ob : INTEGER;
                     ausgeben : BOOLEAN);

VAR i, j, x, y, neue_bakt, gefressen : INTEGER;
    abbruch, loeschen : BOOLEAN;
    taste : CHAR;

BEGIN  { evolution }
  puffer_loeschen;


  abbruch:=FALSE;

  WHILE NOT(abbruch) DO
   BEGIN
     neue_bakt:=0;


{ /////////////////////////////////////////////////////////////////////////// }
     FOR i:=1 TO max_biestzahl DO
      WITH bev[i] DO
       IF NOT(tot)
        THEN BEGIN
               bewege(bev[i], teich, tail);

               gefressen:=mampfe(teich, xposi[1], yposi[1]);
               energie:=round(min(1500.0, (energie + gefressen * 40)));
               neue_bakt:=neue_bakt + gefressen
             END;  { IF }

     vermehre_oder_loesche(bev, teich,
                           biestzahl, max_biestzahl, tail,
                           loeschen);
{ /////////////////////////////////////////////////////////////////////////// }


     IF loeschen THEN clear_links;

     gotoxy(77, 0); write(biestzahl);

     j:=0;
     x:=50;
     i:=1;

     WHILE (i <= max_biestzahl) DO
      WITH bev[i] DO
       BEGIN
         IF NOT(tot) AND ausgeben
          THEN BEGIN
                 gotoxy(x, j);
                 IF (energie < 15) OR (alter > 1985)
                  THEN BEGIN
                         inv_on; write(energie:5, alter:5); inv_off
                       END  { IF }
                  ELSE write(energie:5, alter:5);

                 j:=succ(j);
                 IF (j > 24)
                  THEN BEGIN
                         j:=0; x:=62
                       END  { IF }
               END;  { IF }

         i:=succ(i)
       END;  { WITH }


     i:=li;
     WHILE (i <= re) DO
      BEGIN

        j:=un;
        WHILE (j <= ob) DO
         BEGIN
           IF NOT(teich[i, j])
            THEN BEGIN
                   teich[i, j]:=TRUE; put_pixel(i, j, 1);

                   neue_bakt:=pred(neue_bakt)
                 END;  { IF }

           j:= j + 5
         END;  { WHILE }

        i:=i + 5
      END;  { WHILE }

     FOR i:=1 TO neue_bakt DO
      BEGIN
        x:=random(X_Schirm);
        y:=random(Y_Schirm);
        teich[x, y]:=TRUE;
        put_pixel(x, y, 1)
      END;  { FOR }


     IF cconis THEN taste:=crawcin;
     abbruch:=((taste = '#') OR (biestzahl <= 0))
   END  { WHILE }
END;  { evolution }





BEGIN  { Hauptprogramm }
  puffer_loeschen;
  clear_home;


  xzug[0]:=0; xzug[1]:=2; xzug[2]:=2;  xzug[3]:=0;  xzug[4]:=-2; xzug[5]:=-2;
  yzug[0]:=2; yzug[1]:=1; yzug[2]:=-1; yzug[3]:=-2; yzug[4]:=-1; yzug[5]:=1;


  X_Schirm:=399; Y_Schirm:=399;
  X_Grenze:=X_Schirm - 3; Y_Grenze:=Y_Schirm - 3;


  pli:=150; pre:=250;
  pun:=150; pob:=250;


  biester:=25;
  max_biester:=25;
  schwanz:=10;
  bakterien:=round((succ(X_Schirm) * 0.008125) * succ(Y_Schirm));

  ausg:=TRUE;
  init_biest:=FALSE;
  init_bakt:=FALSE;


  key:='`';

  WHILE (key <> '#') DO
   BEGIN
     clear_links;

     i:=1;
     inv_on;
     gotoxy(50, i); write('Evolution        : e'); i:=i + 2;
     inv_off;
     gotoxy(50, i); 
     IF ausg
      THEN write('mit Textausgabe  : t')
      ELSE write('ohne Textausgabe : t');          i:=succ(i);
     gotoxy(50, i); write('lebende Biester  : b'); i:=succ(i);
     gotoxy(50, i); write('Biester maximal  : m'); i:=succ(i);
     gotoxy(50, i); write('Schwanzlaenge    : s'); i:=i + 2;

     gotoxy(50, i); write('Bakterienzahl    : B'); i:=succ(i);
     gotoxy(50, i); write('Paradiesgrenzen  : p'); i:=succ(i);
     gotoxy(50, i); write('Lebensraum       : l'); i:=i + 2;

     gotoxy(50, i); write('Gene bearbeiten  : g'); i:=i + 2;

     gotoxy(50, i); write('Ende             : #'); i:=i + 2;

     REPEAT
       gotoxy(50, i); write('Eingabe : '); key:=getchar
     UNTIL (key IN ['e', 'B', 't', 'b', 'g', 'l', 'm', 'p', 's', '#', 'X']);

     clear_links;


     CASE key OF

      'X':BEGIN
            gesamt_wahrsch:=0;
            FOR i:=1 TO X_Schirm DO
             FOR j:=1 TO Y_Schirm DO
              IF tuempel[i, j] THEN gesamt_wahrsch:=gesamt_wahrsch + 1.0;

            gotoxy(50, 24); write(round(gesamt_wahrsch));
            key:=getchar
          END;

      'e': BEGIN
             init(pop, tuempel, biester, schwanz, bakterien,
                  pli, pre, pun, pob,
                  init_biest, init_bakt);


             evolution(pop, tuempel, biester, max_biester, schwanz,
                       pli, pre, pun, pob,
                       ausg)
           END;

      'b': BEGIN
             cur_on;
             REPEAT
               clear_links;
               gotoxy(50, 1); write('Biesterzahl: ');
               readln(biester)
             UNTIL (biester > 0) AND (biester <= Max_Nr_Biest);
             cur_off;

             max_biester:=round(min(Max_Nr_Biest, biester * 2));

             init_biest:=FALSE
           END;

      't': ausg:=NOT(ausg);

      'm': BEGIN
             cur_on;
             REPEAT
               clear_links;
               gotoxy(50, 1); write('maximale Biesterzahl: ');
               readln(max_biester)
             UNTIL (max_biester >= biester)
                   AND (max_biester <= Max_Nr_Biest);
             cur_off
           END;

      's': BEGIN
             FOR i:=1 TO max_biester DO
              WITH pop[i] DO
               IF NOT(tot) THEN FOR j:=2 TO schwanz DO
                                 undraw_box(tuempel,
                                            xposi[j], yposi[j],
                                            ((energie < 15) OR
                                             (alter > 1985)));

             cur_on;
             REPEAT
               clear_links;
               gotoxy(50, 1); write('Schwanzlaenge: ');
               readln(schwanz)
             UNTIL (schwanz > 0) AND (schwanz <= Max_Schwanzlaenge);
             cur_off;

             FOR i:=1 TO max_biester DO
              WITH pop[i] DO
               IF NOT(tot)
                THEN FOR j:=2 TO schwanz DO
                      BEGIN
                        xposi[j]:=xposi[1];
                        yposi[j]:=yposi[1]
                      END  { FOR }
           END;

      'B': BEGIN
             cur_on;
             REPEAT
               clear_links;
               gotoxy(50, 1); write('Bakterienzahl: ');
               readln(bakterien)
             UNTIL (bakterien > 0);
             cur_off;

             init_bakt:=FALSE
           END;

      'p': BEGIN
             i:=pli;
             WHILE (i <= pre) DO
              BEGIN

                j:=pun;
                WHILE (j <= pob) DO
                 BEGIN
                   tuempel[i, j]:=FALSE;
                   put_pixel(i, j, 0);

                   j:= j + 5
                 END;  { WHILE }

                i:=i + 5
              END;  { WHILE }


             cur_on;
             REPEAT
               clear_links;
               gotoxy(50, 0); write('Paradiesgrenze');
               gotoxy(50, 1); write('links: ');
               readln(pli)
             UNTIL (pli >= 0) AND (pli <= X_Schirm);

             REPEAT
               clear_links;
               gotoxy(50, 0); write('Paradiesgrenze');
               gotoxy(50, 1); write('rechts: ');
               readln(pre)
             UNTIL (pre > pli) AND (pre <= X_Schirm);

             REPEAT
               clear_links;
               gotoxy(50, 0); write('Paradiesgrenze');
               gotoxy(50, 1); write('unten: ');
               readln(pun)
             UNTIL (pun >= 0) AND (pun <= Y_Schirm);

             REPEAT
               clear_links;
               gotoxy(50, 0); write('Paradiesgrenze');
               gotoxy(50, 1); write('oben: ');
               readln(pob)
             UNTIL (pob >= pun) AND (pob <= Y_Schirm);
             cur_off;


             i:=pli;
             WHILE (i <= pre) DO
              BEGIN

                j:=pun;
                WHILE (j <= pob) DO
                 BEGIN
                   tuempel[i, j]:=TRUE; put_pixel(i, j, 1);

                   j:= j + 5
                 END;  { WHILE }

                i:=i + 5
              END  { WHILE }
           END;

      'l': BEGIN
             cur_on;
             REPEAT
               clear_links;
               gotoxy(50, 1); write('Pixelzahl x: ');
               readln(X_Schirm)
             UNTIL (X_Schirm >= 199) AND (X_Schirm < 400);

             REPEAT
               clear_links;
               gotoxy(50, 1); write('Pixelzahl y: ');
               readln(Y_Schirm)
             UNTIL (Y_Schirm >= 199) AND (Y_Schirm < 400);
             cur_off;


             X_Grenze:=X_Schirm - 3; Y_Grenze:=Y_Schirm - 3;
             bakterien:=round((succ(X_Schirm) * 0.008125) * succ(Y_Schirm));

             init_bakt:=FALSE
           END;

      'g': BEGIN
             i:=1;

             WHILE (i <= max_biester) AND (key <> '#') DO
              BEGIN
                WITH pop[i] DO
                 IF NOT(tot)
                  THEN BEGIN
                         clear_links;

                         gesamt_wahrsch:=0.0;
                         FOR j:=0 TO 5 DO
                          gesamt_wahrsch:=gesamt_wahrsch
                                          + potenz(2.0, gene[j]);


                         FOR j:=0 TO 5 DO
                          BEGIN
                            gotoxy(50, j);

                            CASE j OF
                             0: write('f  : ');
                             1: write('r  : ');
                             2: write('sr : ');
                             3: write('b  : ');
                             4: write('sl : ');
                             5: write('l  : ')
                            END;  { CASE }

                            write(gene[j]:3,
                                  (potenz(2.0, gene[j]) / gesamt_wahrsch):8:4)
                          END;  { FOR }

                         gotoxy(50, 10); write('veraendern (j = ja) ? ');
                         key:=getchar;

                         IF (key = 'j')
                          THEN BEGIN
                                 cur_on;
                                 FOR j:=0 TO 5 DO
                                  BEGIN
                                    gotoxy(50, j + 12);

                                    CASE j OF
                                     0: write('f  : ');
                                     1: write('r  : ');
                                     2: write('sr : ');
                                     3: write('b  : ');
                                     4: write('sl : ');
                                     5: write('l  : ')
                                    END;  { CASE }

                                    readln(gene[j])
                                  END;  { FOR }
                                 cur_off
                               END  { IF }
                       END;  { IF }

                i:=succ(i)
              END;  { WHILE }

             key:='g'
           END

     END  { CASE }
   END  { WHILE }
END.  { Hauptprogramm }

